/***********************************
File name: converter_main-F2806x_1.c
Purpose: Control a DC motor drive
**********************************************/

#include "F2806x_Device.h"


void DeviceInit(void);  // defined in DC_md_DevInit_F2806x.c
void InitEPWMs(void);   // defined in DC_md_PWM_Setup.c
void InitADC(void);		// defined in DC_md_Adc.c

//define interrupt service routines
interrupt void ADCINT1_ISR(void);

Uint32 EndlessLoopCounter = 0;
int AdcIntCounter = 0;

//ADC ISR parameters
Uint16 AdcBuf[50][8]={0};





void main(void)
{ 

// Initialize System Control
// Enable Peripheral Clocks, GPIO
// Initialize the PIE control registers to their default state.
// The default state is all PIE interrupts disabled and flags
// are cleared.
 DeviceInit();
 InitEPWMs();	//Initialize PWM modules
 InitADC();		// Initialize ADC


 //Enable the interrupt
 EALLOW;
 	PieVectTable.ADCINT1=&ADCINT1_ISR;
 EDIS;
 
 PieCtrlRegs.PIEIER1.bit.INTx1=1;
 IER |= M_INT1;
 EINT;	
 	    
  for(;;)  //infinite loop
  {
    asm(" NOP"); 
    if (EndlessLoopCounter++ >= 4294967295)
    {
       EndlessLoopCounter=0;
    }    
  }
  
}// end of main




	


interrupt void ADCINT1_ISR(void)
{
	static int index = 0;
		
	//Store the converted values in a circular array:
	AdcBuf[index][0]=AdcResult.ADCRESULT0;
	AdcBuf[index][1]=AdcResult.ADCRESULT1;
	AdcBuf[index][2]=AdcResult.ADCRESULT2;
	AdcBuf[index][3]=AdcResult.ADCRESULT3;
	AdcBuf[index][4]=AdcResult.ADCRESULT4;
	AdcBuf[index][5]=AdcResult.ADCRESULT5;
	AdcBuf[index][6]=AdcResult.ADCRESULT6;
	AdcBuf[index][7]=AdcResult.ADCRESULT7;
	
	index ++;
	if (index == 50) index =0;

	static int indexB = 1;
	indexB ++;
	
	
		
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;		// Must acknowledge the PIE group
	AdcRegs.ADCINTFLGCLR.bit.ADCINT1 = 1;		// Clear ADCINT1 flag to enable further interrupts
	
	//ADC interrupt counter
	  AdcIntCounter++;
      if (AdcIntCounter >=200)
        AdcIntCounter=0;
        
} //end of ADCINT1_ISR
