//###########################################################################
//
// FILE:	Example_EpwmSetup.c
//
// TITLE:	Pos speed measurement using EQEP peripheral
//
// DESCRIPTION: This is for the verification of the speed measurements and speed controller algorithm
//
// This file contains source for the ePWM initialization for the 
// pos/speed module
//
//###########################################################################
// $TI Release: F2806x C/C++ Header Files and Peripheral Examples V130 $ 
// $Release Date: November 30, 2011 $ 
//###########################################################################

#include "DSP28x_Project.h"     // Device Headerfile and Examples Include File


#define CPU_CLK   80e6

#define PWM_CLK   5e3              // 5kHz (300rpm) EPWM1 frequency. Freq. can be changed here
#define SP        CPU_CLK/(2*PWM_CLK)
#define TBCTLVAL  0x200E           // up-down count, timebase=SYSCLKOUT

void InitEPWM4()
{
	EPwm4Regs.TBSTS.all=0;
	EPwm4Regs.TBPHS.half.TBPHS =0;
	EPwm4Regs.TBCTR=0;

	EPwm4Regs.CMPCTL.all=0x50;     // immediate mode for CMPA and CMPB   
	EPwm4Regs.CMPA.half.CMPA=SP/2;
	EPwm4Regs.CMPB=0;
	
	EPwm4Regs.AQCTLA.all=0x60;     // CTR=CMPA when inc->EPWM1A=1, when dec->EPWM1A=0
	EPwm4Regs.AQCTLB.all=0x09;     // CTR=PRD ->EPWM1B=1, CTR=0 ->EPWM1B=0  
	EPwm4Regs.AQSFRC.all=0;
	EPwm4Regs.AQCSFRC.all=0;
	
	EPwm4Regs.TZSEL.all=0;
	EPwm4Regs.TZCTL.all=0;
	EPwm4Regs.TZEINT.all=0;
	EPwm4Regs.TZFLG.all=0;
	EPwm4Regs.TZCLR.all=0;
	EPwm4Regs.TZFRC.all=0;

	//EPwm4Regs.ETSEL.all=0x0A;      // Interrupt on PRD 
	//EPwm4Regs.ETPS.all=1;	
	//EPwm4Regs.ETFLG.all=0;
	//EPwm4Regs.ETCLR.all=0;
	//EPwm4Regs.ETFRC.all=0;
	
	EPwm4Regs.PCCTL.all=0;
	
	EPwm4Regs.TBCTL.all=0x0010+TBCTLVAL; // Enable Timer
	EPwm4Regs.TBPRD=SP;
	
}

