//----------------------------------------------------------------------------------
//	FILE:			DC_md_QEP_Setup.c
//	Description:	QEP setup for speed measurements and speed controller
//	Version: 		1.0
//  Target:  		TMS320F2806x family
//	Type: 			Device Dependent
//  Copyright       Texas Instruments
//  Date:  			April 2012 
//----------------------------------------------------------------------------------

#include "F2806x_Device.h"           		// DSP2860x Headerfile Include File


void InitEQEP()
{
	
	  	EQep1Regs.QUPRD=800000;         	// Unit Timer = 100Hz=80 MHz/800000.
	  	EQep1Regs.QDECCTL.bit.QSRC=00;      // QEP quadrature count mode
	  
	  	EQep1Regs.QEPCTL.bit.FREE_SOFT=2;	// Position counter is unaffected by emulation suspend
	  	EQep1Regs.QEPCTL.bit.PCRM=11;       // PCRM=11 mode: on unit time out event: 
	  										// QPOSCNT is latched into QPOSLAT and reset 
	  	EQep1Regs.QEPCTL.bit.UTE=1;         // Unit Timer Enable
	  	
	  	EQep1Regs.QPOSMAX=4294967295;		// Max value of POSCNT, = max value of 32 bit int. 
	  	EQep1Regs.QEPCTL.bit.QPEN=1;        // QEP enable
	  	
	  	EQep1Regs.QCAPCTL.bit.UPPS=2;       // 1/4 for unit position
    	EQep1Regs.QCAPCTL.bit.CCPS=6;       // 1/64 for CAP clock
   		EQep1Regs.QCAPCTL.bit.CEN=1;        // QEP Capture Enable
   		EQep1Regs.QEPCTL.bit.QCLM=1;        // Latch on unit time out
   		
   		EQep1Regs.QEINT.bit.UTO=1;       	// Enable unit time out interrupt
   		
   		EQep1Regs.QFLG.bit.UTO=1;			// Unit time out interrupt flag: Set by eQEP unit timer period match	
   	
} // end InitEQEP()
//--- end of file -----------------------------------------------------

